## scotch 6.0.0

=== src/Makefile ===
## Copyright 2004,2007,2008,2010-2012 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

VERSION	= 6
RELEASE = 0
PATCHLEVEL = 0

.PHONY				:	clean	default	install	ptscotch	realclean	required	scotch

default				:	scotch

required			:	Makefile.inc	../bin	../include	../lib

Makefile.inc			:
					@echo "#####################################################################"
			        	@echo "BEFORE COMPILING Scotch OR PT-Scotch, YOU SHOULD HAVE AN APPROPRIATE"
					@echo "Makefile.inc FILE IN THIS DIRECTORY. PLEASE LOOK INTO DIRECTORY"
	        			@echo " ./Make.inc FOR AN EXISTING Makefile.inc FILE THAT FITS YOUR NEED, OR"
		        		@echo "USE THEM AS MODELS IN CASE YOU NEED TO BUILD A NEW ONE FOR YOUR"
		        		@echo "PARTICULAR PLATFORM."
			        	@echo "#####################################################################"
			        	@echo "Then, type \"make scotch\" (default) for the sequential library"
			        	@echo "and software, or \"make ptscotch\" for the parallel library and"
			        	@echo "software."
					@exit 1

include Makefile.inc

prefix		?= /usr/local
bindir		?= $(prefix)/bin
includedir	?= $(prefix)/include
libdir		?= $(prefix)/lib
datarootdir	?= $(prefix)/share
mandir		?= $(datarootdir)/man

../bin				:
					-$(MKDIR) ../bin

../include			:
					-$(MKDIR) ../include

../lib				:
					-$(MKDIR) ../lib

$(bindir)			:
					-$(MKDIR) $(bindir)

$(datarootdir)			:
					-$(MKDIR) $(datarootdir)

$(includedir)			:
					-$(MKDIR) $(includedir)

$(libdir)			:
					-$(MKDIR) $(libdir)

$(mandir)			:	$(datarootdir)
					-$(MKDIR) $(mandir)

$(mandir)/man1			:	$(mandir)
					-$(MKDIR) $(mandir)/man1

scotch				:	required
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) scotch && $(MAKE) install)
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) scotch && $(MAKE) install)
					(cd libscotchmetis ; $(MAKE)                                                                scotch && $(MAKE) install)

ptscotch			:	required
					(cd libscotch ;      $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) ptscotch && $(MAKE) ptinstall)
					(cd scotch ;         $(MAKE) VERSION=$(VERSION) RELEASE=$(RELEASE) PATCHLEVEL=$(PATCHLEVEL) ptscotch && $(MAKE) ptinstall)
					(cd libscotchmetis ; $(MAKE)                                                                ptscotch && $(MAKE) ptinstall)

check				:	scotch
					(cd check ; $(MAKE) check)

ptcheck				:	ptscotch
					(cd check ; $(MAKE) ptcheck)

install				:	required	$(bindir)	$(includedir)	$(libdir)	$(mandir)/man1
					-$(CP) -f ../bin/[agm]*$(EXE) $(bindir)
					-$(CP) -f ../bin/d[agm]*$(EXE) $(bindir)
					-$(CP) -f ../include/*scotch*.h $(includedir)
					-$(CP) -f ../lib/*scotch*$(LIB) $(libdir)
					-$(CP) -Rf ../man/* $(mandir)

clean				:	required
					(cd libscotch ;      $(MAKE) clean)
					(cd scotch ;         $(MAKE) clean)
					(cd libscotchmetis ; $(MAKE) clean)
					(cd check ;          $(MAKE) clean)

realclean			:	required
					(cd libscotch ;      $(MAKE) realclean)
					(cd scotch ;         $(MAKE) realclean)
					(cd libscotchmetis ; $(MAKE) realclean)
					(cd check ;          $(MAKE) realclean)
					-$(RM) ../bin/* ../include/* ../lib/*

## scotch 6.0.4.dfsg1

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-## Copyright 2004,2007,2008,2010-2012 IPB, Universite de Bordeaux, INRIA & CNRS
+## Copyright 2004,2007,2008,2010-2012,2014 IPB, Universite de Bordeaux, INRIA & CNRS
 ##
 ## This file is part of the Scotch software package for static mapping,
 ## graph partitioning and sparse matrix ordering.
@@ -32,7 +32,7 @@
 
 VERSION	= 6
 RELEASE = 0
-PATCHLEVEL = 0
+PATCHLEVEL = 4
 
 .PHONY				:	clean	default	install	ptscotch	realclean	required	scotch
 
@@ -105,6 +105,12 @@
 ptcheck				:	ptscotch
 					(cd check ; $(MAKE) ptcheck)
 
+esmumps				:	scotch
+					(cd esmumps ; $(MAKE) scotch && $(MAKE) install)
+
+ptesmumps			:	ptscotch
+					(cd esmumps ; $(MAKE) ptscotch && $(MAKE) ptinstall)
+
 install				:	required	$(bindir)	$(includedir)	$(libdir)	$(mandir)/man1
 					-$(CP) -f ../bin/[agm]*$(EXE) $(bindir)
 					-$(CP) -f ../bin/d[agm]*$(EXE) $(bindir)
@@ -117,10 +123,12 @@
 					(cd scotch ;         $(MAKE) clean)
 					(cd libscotchmetis ; $(MAKE) clean)
 					(cd check ;          $(MAKE) clean)
+					(cd esmumps ;        $(MAKE) clean)
 
 realclean			:	required
 					(cd libscotch ;      $(MAKE) realclean)
 					(cd scotch ;         $(MAKE) realclean)
 					(cd libscotchmetis ; $(MAKE) realclean)
 					(cd check ;          $(MAKE) realclean)
+					(cd esmumps ;        $(MAKE) realclean)
 					-$(RM) ../bin/* ../include/* ../lib/*

=== src/libscotch/Makefile ===
## Copyright 2004,2007-2013 IPB, Universite de Bordeaux, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

includedir	= ../../include
libdir		= ../../lib

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -c $(<) -o $(@)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -DSCOTCH_VERSION=$(VERSION) -DSCOTCH_RELEASE=$(RELEASE) -DSCOTCH_PATCHLEVEL=$(PATCHLEVEL) $(<) -o $(@) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) CC="$(CCS)" CCD="$(CCS)"	\
					scotch.h				\
					scotchf.h				\
					libscotch$(LIB)				\
					libscotcherr$(LIB)			\
					libscotcherrexit$(LIB)

ptscotch			:	scotch
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)"	\
					ptscotch.h							\
					ptscotchf.h							\
					libptscotch$(LIB)						\
					libptscotcherr$(LIB)						\
					libptscotcherrexit$(LIB)

install				:	$(includedir)/scotch.h			\
					$(includedir)/scotchf.h			\
					$(libdir)/libscotch$(LIB)

ptinstall			:	install					\
					$(includedir)/ptscotch.h		\
					$(includedir)/ptscotchf.h		\
					$(libdir)/libptscotch$(LIB)

clean				:
					-$(RM) *~ *$(OBJ) lib*$(LIB) parser_yy.c parser_ly.h parser_ll.c *scotch.h *scotchf.h y.output *dummysizes$(EXE)

realclean			:	clean


##
##  Installation dependencies
##

$(includedir)/scotch.h		:	scotch.h
					-$(CP) scotch.h $(includedir)

$(includedir)/scotchf.h		:	scotchf.h
					-$(CP) scotchf.h $(includedir)

$(includedir)/ptscotch.h	:	ptscotch.h
					-$(CP) ptscotch.h $(includedir)

$(includedir)/ptscotchf.h	:	ptscotchf.h
					-$(CP) ptscotchf.h $(includedir)

$(libdir)/libscotch$(LIB)	:	libscotch$(LIB)
					-$(CP) libscotch$(LIB) libscotcherr*$(LIB) $(libdir)

$(libdir)/libptscotch$(LIB)	:	libptscotch$(LIB)
					-$(CP) libptscotch$(LIB) libptscotcherr*$(LIB) $(libdir)

##
##  Library dependencies.
##

LIBPTSCOTCHDEPS =	bdgraph$(OBJ)				\
			bdgraph_bipart_bd$(OBJ)			\
			bdgraph_bipart_df$(OBJ)			\
			bdgraph_bipart_ex$(OBJ)			\
			bdgraph_bipart_ml$(OBJ)			\
			bdgraph_bipart_sq$(OBJ)			\
			bdgraph_bipart_st$(OBJ)			\
			bdgraph_bipart_zr$(OBJ)			\
			bdgraph_check$(OBJ)			\
			bdgraph_gather_all$(OBJ)		\
			bdgraph_store$(OBJ)			\
			comm$(OBJ)				\
			dgraph$(OBJ)				\
			dgraph_allreduce$(OBJ)			\
			dgraph_band$(OBJ)			\
			dgraph_build$(OBJ)			\
			dgraph_build_grid3d$(OBJ)		\
			dgraph_build_hcub$(OBJ)			\
			dgraph_check$(OBJ)			\
			dgraph_coarsen$(OBJ)			\
			dgraph_fold$(OBJ)			\
			dgraph_fold_comm$(OBJ)			\
			dgraph_fold_dup$(OBJ)			\
			dgraph_gather$(OBJ)			\
			dgraph_gather_all$(OBJ)			\
			dgraph_ghst$(OBJ)			\
			dgraph_halo$(OBJ)			\
			dgraph_induce$(OBJ)			\
			dgraph_io_load$(OBJ)			\
			dgraph_io_save$(OBJ)			\
			dgraph_match$(OBJ)			\
			dgraph_match_sync_coll$(OBJ)		\
			dgraph_match_sync_ptop$(OBJ)		\
			dgraph_match_check$(OBJ)		\
			dgraph_redist$(OBJ)			\
			dgraph_scatter$(OBJ)			\
			dgraph_view$(OBJ)			\
			dmapping$(OBJ)				\
			dmapping_io$(OBJ)			\
			dorder$(OBJ)				\
			dorder_gather$(OBJ)			\
			dorder_io$(OBJ)				\
			dorder_io_block$(OBJ)			\
			dorder_io_tree$(OBJ)			\
			dorder_perm$(OBJ)			\
			dorder_tree_dist$(OBJ)			\
			hdgraph$(OBJ)				\
			hdgraph_check$(OBJ)			\
			hdgraph_fold$(OBJ)			\
			hdgraph_gather$(OBJ)			\
			hdgraph_induce$(OBJ)			\
			hdgraph_order_nd$(OBJ)			\
			hdgraph_order_si$(OBJ)			\
			hdgraph_order_sq$(OBJ)			\
			hdgraph_order_st$(OBJ)			\
			kdgraph$(OBJ)				\
			kdgraph_gather$(OBJ)			\
			kdgraph_map_rb$(OBJ)			\
			kdgraph_map_rb_map$(OBJ)		\
			kdgraph_map_rb_part$(OBJ)		\
			kdgraph_map_st$(OBJ)			\
			library_dgraph$(OBJ)			\
			library_dgraph_f$(OBJ)			\
			library_dgraph_band$(OBJ)		\
			library_dgraph_band_f$(OBJ)		\
			library_dgraph_build$(OBJ)		\
			library_dgraph_build_f$(OBJ)		\
			library_dgraph_build_grid3d$(OBJ)	\
			library_dgraph_build_grid3d_f$(OBJ)	\
			library_dgraph_check$(OBJ)		\
			library_dgraph_check_f$(OBJ)		\
			library_dgraph_coarsen$(OBJ)		\
			library_dgraph_coarsen_f$(OBJ)		\
			library_dgraph_gather$(OBJ)		\
			library_dgraph_gather_f$(OBJ)		\
			library_dgraph_grow$(OBJ)		\
			library_dgraph_halo$(OBJ)		\
			library_dgraph_halo_f$(OBJ)		\
			library_dgraph_induce$(OBJ)		\
			library_dgraph_induce_f$(OBJ)		\
			library_dgraph_io_load$(OBJ)		\
			library_dgraph_io_load_f$(OBJ)		\
			library_dgraph_io_save$(OBJ)		\
			library_dgraph_io_save_f$(OBJ)		\
			library_dgraph_map$(OBJ)		\
			library_dgraph_map_f$(OBJ)		\
			library_dgraph_map_view$(OBJ)		\
			library_dgraph_map_view_f$(OBJ)		\
			library_dgraph_order$(OBJ)		\
			library_dgraph_order_f$(OBJ)		\
			library_dgraph_order_gather$(OBJ)	\
			library_dgraph_order_gather_f$(OBJ)	\
			library_dgraph_order_io$(OBJ)		\
			library_dgraph_order_io_f$(OBJ)		\
			library_dgraph_order_io_block$(OBJ)	\
			library_dgraph_order_io_block_f$(OBJ)	\
			library_dgraph_order_perm$(OBJ)		\
			library_dgraph_order_perm_f$(OBJ)	\
			library_dgraph_order_tree_dist$(OBJ)	\
			library_dgraph_order_tree_dist_f$(OBJ)	\
			library_dgraph_redist$(OBJ)		\
			library_dgraph_redist_f$(OBJ)		\
			library_dgraph_scatter$(OBJ)		\
			library_dgraph_scatter_f$(OBJ)		\
			library_dgraph_stat$(OBJ)		\
			library_dgraph_stat_f$(OBJ)		\
			library_dmapping$(OBJ)			\
			library_dorder$(OBJ)			\
			vdgraph$(OBJ)				\
			vdgraph_check$(OBJ)			\
			vdgraph_gather_all$(OBJ)		\
			vdgraph_separate_bd$(OBJ)		\
			vdgraph_separate_df$(OBJ)		\
			vdgraph_separate_ml$(OBJ)		\
			vdgraph_separate_sq$(OBJ)		\
			vdgraph_separate_st$(OBJ)		\
			vdgraph_separate_zr$(OBJ)		\
			vdgraph_store$(OBJ)

LIBSCOTCHDEPS	=	arch$(OBJ)				\
			arch_build$(OBJ)			\
			arch_cmplt$(OBJ)			\
			arch_cmpltw$(OBJ)			\
			arch_deco$(OBJ)				\
			arch_dist$(OBJ)				\
			arch_hcub$(OBJ)				\
			arch_mesh$(OBJ)				\
			arch_tleaf$(OBJ)			\
			arch_torus$(OBJ)			\
			arch_vcmplt$(OBJ)			\
			arch_vhcub$(OBJ)			\
			bgraph$(OBJ)				\
			bgraph_bipart_bd$(OBJ)			\
			bgraph_bipart_df$(OBJ)			\
			bgraph_bipart_ex$(OBJ)			\
			bgraph_bipart_fm$(OBJ)			\
			bgraph_bipart_gg$(OBJ)			\
			bgraph_bipart_gp$(OBJ)			\
			bgraph_bipart_ml$(OBJ)			\
			bgraph_bipart_st$(OBJ)			\
			bgraph_bipart_zr$(OBJ)			\
			bgraph_check$(OBJ)			\
			bgraph_store$(OBJ)			\
			common$(OBJ)				\
			common_file$(OBJ)			\
			common_file_compress$(OBJ)		\
			common_file_uncompress$(OBJ)		\
			common_integer$(OBJ)			\
			common_memory$(OBJ)			\
			common_string$(OBJ)			\
			common_stub$(OBJ)			\
			common_thread$(OBJ)			\
			fibo$(OBJ)				\
			gain$(OBJ)				\
			geom$(OBJ)				\
			graph$(OBJ)				\
			graph_base$(OBJ)			\
			graph_band$(OBJ)			\
			graph_check$(OBJ)			\
			graph_coarsen$(OBJ)			\
			graph_induce$(OBJ)			\
			graph_io$(OBJ)				\
			graph_io_chac$(OBJ)			\
			graph_io_habo$(OBJ)			\
			graph_io_mmkt$(OBJ)			\
			graph_io_scot$(OBJ)			\
			graph_list$(OBJ)			\
			graph_match$(OBJ)			\
			hall_order_hd$(OBJ)			\
			hall_order_hf$(OBJ)			\
			hall_order_hx$(OBJ)			\
			hgraph$(OBJ)				\
			hgraph_check$(OBJ)			\
			hgraph_induce$(OBJ)			\
			hgraph_order_bl$(OBJ)			\
			hgraph_order_cp$(OBJ)			\
			hgraph_order_gp$(OBJ)			\
			hgraph_order_hd$(OBJ)			\
			hgraph_order_hf$(OBJ)			\
			hgraph_order_hx$(OBJ)			\
			hgraph_order_kp$(OBJ)			\
			hgraph_order_nd$(OBJ)			\
			hgraph_order_si$(OBJ)			\
			hgraph_order_st$(OBJ)			\
			hmesh$(OBJ)				\
			hmesh_check$(OBJ)			\
			hmesh_hgraph$(OBJ)			\
			hmesh_induce$(OBJ)			\
			hmesh_mesh$(OBJ)			\
			hmesh_order_bl$(OBJ)			\
			hmesh_order_cp$(OBJ)			\
			hmesh_order_gr$(OBJ)			\
			hmesh_order_gp$(OBJ)			\
			hmesh_order_hd$(OBJ)			\
			hmesh_order_hf$(OBJ)			\
			hmesh_order_hx$(OBJ)			\
			hmesh_order_nd$(OBJ)			\
			hmesh_order_si$(OBJ)			\
			hmesh_order_st$(OBJ)			\
			kgraph$(OBJ)				\
			kgraph_band$(OBJ)			\
			kgraph_check$(OBJ)			\
			kgraph_map_bd$(OBJ)			\
			kgraph_map_cp$(OBJ)			\
			kgraph_map_df$(OBJ)			\
			kgraph_map_ex$(OBJ)			\
			kgraph_map_fm$(OBJ)			\
			kgraph_map_ml$(OBJ)			\
			kgraph_map_rb$(OBJ)			\
			kgraph_map_rb_map$(OBJ)			\
			kgraph_map_rb_part$(OBJ)		\
			kgraph_map_st$(OBJ)			\
			kgraph_store$(OBJ)			\
			library_arch$(OBJ)			\
			library_arch_f$(OBJ)			\
			library_arch_build$(OBJ)		\
			library_arch_build_f$(OBJ)		\
			library_common_f$(OBJ)			\
			library_geom$(OBJ)			\
			library_geom_f$(OBJ)			\
			library_graph$(OBJ)			\
			library_graph_f$(OBJ)			\
			library_graph_base$(OBJ)		\
			library_graph_base_f$(OBJ)		\
			library_graph_check$(OBJ)		\
			library_graph_check_f$(OBJ)		\
			library_graph_coarsen$(OBJ)		\
			library_graph_coarsen_f$(OBJ)		\
			library_graph_color$(OBJ)		\
			library_graph_color_f$(OBJ)		\
			library_graph_io_chac$(OBJ)		\
			library_graph_io_chac_f$(OBJ)		\
			library_graph_io_habo$(OBJ)		\
			library_graph_io_habo_f$(OBJ)		\
			library_graph_io_mmkt$(OBJ)		\
			library_graph_io_mmkt_f$(OBJ)		\
			library_graph_io_scot$(OBJ)		\
			library_graph_io_scot_f$(OBJ)		\
			library_graph_map$(OBJ)			\
			library_graph_map_f$(OBJ)		\
			library_graph_map_io$(OBJ)		\
			library_graph_map_io_f$(OBJ)		\
			library_graph_map_view$(OBJ)		\
			library_graph_map_view_f$(OBJ)		\
			library_graph_order$(OBJ)		\
			library_graph_order_f$(OBJ)		\
			library_graph_part_ovl$(OBJ)		\
			library_graph_part_ovl_f$(OBJ)		\
			library_mapping$(OBJ)			\
			library_memory$(OBJ)			\
			library_memory_f$(OBJ)			\
			library_mesh$(OBJ)			\
			library_mesh_f$(OBJ)			\
			library_mesh_graph$(OBJ)		\
			library_mesh_graph_f$(OBJ)		\
			library_mesh_io_habo$(OBJ)		\
			library_mesh_io_habo_f$(OBJ)		\
			library_mesh_io_scot$(OBJ)		\
			library_mesh_io_scot_f$(OBJ)		\
			library_mesh_order$(OBJ)		\
			library_mesh_order_f$(OBJ)		\
			library_order$(OBJ)			\
			library_parser$(OBJ)			\
			library_parser_f$(OBJ)			\
			library_random$(OBJ)			\
			library_random_f$(OBJ)			\
			library_strat$(OBJ)			\
			library_version$(OBJ)			\
			library_version_f$(OBJ)			\
			mapping$(OBJ)				\
			mapping_io$(OBJ)			\
			mesh$(OBJ)				\
			mesh_check$(OBJ)			\
			mesh_coarsen$(OBJ)			\
			mesh_graph$(OBJ)			\
			mesh_induce_sepa$(OBJ)			\
			mesh_io$(OBJ)				\
			mesh_io_habo$(OBJ)			\
			mesh_io_scot$(OBJ)			\
			order$(OBJ)				\
			order_check$(OBJ)			\
			order_io$(OBJ)				\
			parser$(OBJ)				\
			parser_ll$(OBJ)				\
			parser_yy$(OBJ)				\
			vgraph$(OBJ)				\
			vgraph_check$(OBJ)			\
			vgraph_separate_bd$(OBJ)		\
			vgraph_separate_df$(OBJ)		\
			vgraph_separate_es$(OBJ)		\
			vgraph_separate_fm$(OBJ)		\
			vgraph_separate_gg$(OBJ)		\

=== src/libscotchmetis/Makefile ===
## Copyright 2007-2010 ENSEIRB, INRIA & CNRS
##
## This file is part of the Scotch software package for static mapping,
## graph partitioning and sparse matrix ordering.
##
## This software is governed by the CeCILL-C license under French law
## and abiding by the rules of distribution of free software. You can
## use, modify and/or redistribute the software under the terms of the
## CeCILL-C license as circulated by CEA, CNRS and INRIA at the following
## URL: "http://www.cecill.info".
## 
## As a counterpart to the access to the source code and rights to copy,
## modify and redistribute granted by the license, users are provided
## only with a limited warranty and the software's author, the holder of
## the economic rights, and the successive licensors have only limited
## liability.
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading, using, modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean that it is complicated to manipulate, and that also
## therefore means that it is reserved for developers and experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards
## their requirements in conditions enabling the security of their
## systems and/or data to be ensured and, more generally, to use and
## operate it in the same conditions as regards security.
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL-C license and that you accept its terms.
##

bindir		= ../../bin
includedir	= ../../include
libdir		= ../../lib

##
##  General inference rules.
##

include ../Makefile.inc

%$(OBJ)	:	%.c
				$(CC) $(CFLAGS) $(CLIBFLAGS) -I$(includedir) -I../libscotch -c $(<) -o $(@)

%$(EXE)	:	%.c
		 		$(CC) $(CFLAGS) -I$(includedir) -I../libscotch $(<) -o $(@) -L$(libdir) $(LDFLAGS)

##
##  Project rules.
##

.PHONY				:	ptscotch	scotch	ptinstall	install	clean	realclean

scotch				:
					$(MAKE) CC="$(CCS)" SCOTCHLIB=ptscotch						\
					libscotchmetis$(LIB)

ptscotch			:
					$(MAKE) CFLAGS="$(CFLAGS) -DSCOTCH_PTSCOTCH" CC="$(CCP)" SCOTCHLIB=ptscotch	\
					libptscotchparmetis$(LIB)

install				:	scotch
					-$(CP) metis.h $(includedir)
					-$(CP) libscotchmetis$(LIB) $(libdir)

ptinstall			:	ptscotch
					-$(CP) parmetis.h $(includedir)
					-$(CP) libptscotchparmetis$(LIB) $(libdir)

clean				:
					-$(RM) *~ *$(OBJ) lib*$(LIB)

realclean			:	clean

##
##  Todo list.
##

metis_graph_order$(OBJ)		:	metis_graph_order.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_order_f$(OBJ)	:	metis_graph_order_f.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_part$(OBJ)		:	metis_graph_part.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

metis_graph_part_f$(OBJ)	:	metis_graph_part_f.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/scotch.h			\
					metis.h

parmetis_dgraph_order$(OBJ)	:	parmetis_dgraph_order.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_order_f$(OBJ)	:	parmetis_dgraph_order_f.c		\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_part$(OBJ)	:	parmetis_dgraph_part.c			\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

parmetis_dgraph_part_f$(OBJ)	:	parmetis_dgraph_part_f.c		\
					../libscotch/module.h			\
					../libscotch/common.h			\
					$(includedir)/ptscotch.h		\
					parmetis.h

libptscotchparmetis$(LIB)	:	parmetis_dgraph_order$(OBJ)		\
					parmetis_dgraph_order_f$(OBJ)		\
					parmetis_dgraph_part$(OBJ)		\
					parmetis_dgraph_part_f$(OBJ)
					$(AR) $(ARFLAGS) $(@) $(^)
					-$(RANLIB) $(@)

libscotchmetis$(LIB)		:	metis_graph_order$(OBJ)			\
					metis_graph_order_f$(OBJ)		\
					metis_graph_part$(OBJ)			\
					metis_graph_part_f$(OBJ)
					$(AR) $(ARFLAGS) $(@) $(^)
					-$(RANLIB) $(@)

=== debian/changelog ===
scotch (6.0.4.dfsg1-8) unstable; urgency=medium

  * Team upload.
  * Don't halt on test errors for powerpcspe
    (may segfault on INTSIZE64, but the default INT is still useful)
  * Skip tests altogether on hurd, m68k (their timeout and qemu test
    failures can't simply be ignored).
  * Create a fill-in man page scotch_binaries.1 to cover sundry
    binaries scotch_esmumps, scotch_gbase, acpl, amk_grf, mcv for which
    a man page is not available. Closes: #883824.
  * Install with executable [pt]scotch.install to distinguish scotch
    from ptscotch binaries at package build time.
  * debian patch fix_manpages.patch fixes errors using quotes '' at
    the beginning of lines in gout and dgscat man pages.
  * Use automatic symbol packages (-dbgsym) instead of old -dbg packages
  * Standards-Version: 4.1.2

 -- Drew Parsons <dparsons@debian.org>  Wed, 20 Dec 2017 14:29:43 +0800

scotch (6.0.4.dfsg1-7) unstable; urgency=medium

  * Team upload.
  * Don't halt on test errors on hurd, m68k:
    - hurd times out on buildd during build-time checks
    - m68k segfaults inside the qemu emulator used for builds

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Nov 2017 10:45:25 +0800

scotch (6.0.4.dfsg1-6) unstable; urgency=medium

  * Team upload.
  * debian/rules: provide path to built libs (LD_LIBRARY_PATH) when
    running build-time checks.
    - should enable tests to run successfully, so reinstate
      halt-on-error for checks
  * -DSCOTCH_PTHREAD_AFFINITY_LINUX (pthread_setaffinity_np) is not
    supported by hurd (kfreebsd does support it)

 -- Drew Parsons <dparsons@debian.org>  Sun, 26 Nov 2017 22:59:12 +0800

scotch (6.0.4.dfsg1-5) unstable; urgency=medium

  * Team upload.
  * debian/rules: apply "set -e" at the build step to halt on build
    error. Closes: #865671.
    - treat tests (make check) as information-only, don't halt on
      check failure
  * improve thread handling with -DSCOTCH_PTHREAD_NUMBER=2 and
    -DSCOTCH_PTHREAD_AFFINITY_LINUX (see INSTALL.txt)

 -- Drew Parsons <dparsons@debian.org>  Sun, 26 Nov 2017 10:29:40 +0800

scotch (6.0.4.dfsg1-4) unstable; urgency=medium

  * Team upload.
  * Rename correct-ptscotch-header.patch as include_headers.patch:
    include scotch.h in [par]metis.h to define SCOTCH_Num.
  * Include stdio.h in scotch.h (in C).

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Nov 2017 01:01:42 +0800

scotch (6.0.4.dfsg1-3) unstable; urgency=medium

  * Team upload.
  * Reorganise debian's Makefile_*.inc makefile fragments to use a
    common CFLAGS and LDFLAGS (defined in debian/rules).
  * add HAVE_SYS_TIME_H to hurd flags to ensure timeval is defined.
    Closes: #881200.

 -- Drew Parsons <dparsons@debian.org>  Fri, 10 Nov 2017 13:25:40 +0800

scotch (6.0.4.dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Upload scotch 6 to unstable.

 -- Drew Parsons <dparsons@debian.org>  Wed, 08 Nov 2017 15:41:18 +0800

scotch (6.0.4.dfsg1-1exp1) experimental; urgency=medium

  * Team upload.

  [ Nico Schlömer ]
  * New upstream release. Closes: #731965.

  [ Christophe Trophime ]
  * debian patch correct-ptscotch-header.patch: include mpi.h.
  * debian/Makefile*: fix patchlevel version

  [ Drew Parsons ]
  * Standards-Version: 4.1.1
  * debhelper compatibility level 10
  * debian/control: Priority: optional not extra
  * shared directories use multiarch /usr/lib/${DEB_HOST_MULTIARCH}
  * scotch: install scotch_gpart alongside scotch_gmap. Closes: #728995.

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 Oct 2017 03:11:16 +0800

scotch (6.0.0.dfsg-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release
  * debian/control:
     - Standards-Version: 3.9.4 (no changes needed)

 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Thu, 05 Sep 2013 08:36:12 +0200

scotch (5.1.12b.dfsg-3) unstable; urgency=low

  * debian/control
      remove obsolete DM-Upload-Allowed 
  * debian/rules
      modify install target: add cstdio include to [pt]scotch.h 
      Fix broken symlinks (Closes: #715107)
      Fix [par]metis-compatibility symlinks (Closes: #715112)
  * update build-fixes.patch (fix ld warnings)
  
 -- Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>  Fri, 19 Aug 2013 14:15:10 +0100

=== debian/control ===
Source: scotch
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 10),
    quilt,
    bison, flex,
    zlib1g-dev,
    chrpath,
    mpi-default-dev, mpi-default-bin
Standards-Version: 4.1.2
Vcs-Git: git://anonscm.debian.org/debian-science/packages/scotch.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/scotch.git
Homepage: http://www.labri.fr/perso/pelegrin/scotch/

Package: scotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Its purpose is to apply graph theory, with a divide and conquer
 approach, to scientific computing problems such as graph and mesh
 partitioning, static mapping, and sparse matrix ordering, in
 application domains ranging from structural mechanics to operating
 systems or bio-chemistry.
 .
 The SCOTCH distribution is a set of programs and libraries which
 implement the static mapping and sparse matrix reordering algorithms
 developed within the SCOTCH project.
 .
 SCOTCH has many interesting features:
 .
 o Its capabilities can be used through a set of stand-alone programs
 as well as through the libSCOTCH library, which offers both C and
 Fortran interfaces.
 .
 o It provides algorithms to partition graph structures, as well as
 mesh structures defined as node-element bipartite graphs and which
 can also represent hypergraphs.
 .
 o It can map any weighted source graph onto any weighted target
 graph. The source and target graphs may have any topology, and their
 vertices and edges may be weighted. Moreover, both source and target
 graphs may be disconnected. This feature allows for the mapping of
 programs onto disconnected subparts of a parallel architecture made
 up of heterogeneous processors and communication links.
 .
 o It computes amalgamated block orderings of sparse matrices, for
 efficient solving using BLAS routines.
 .
 o Its running time is linear in the number of edges of the source
 graph, and logarithmic in the number of vertices of the target graph
 for mapping computations.
 .
 o It can handle indifferently graph and mesh data structures created
 within C or Fortran programs, with array indices starting from 0 or
 1.
 .
 o It offers extended support for adaptive graphs and meshes through
 the handling of disjoint edge arrays.
 .
 o It is dynamically parametrizable thanks to strategy strings that
 are interpreted at run-time.
 .
 o It uses system memory efficiently, to process large graphs and
 meshes without incurring out-of-memory faults;
 .
 o It is highly modular and documented. Since it has been released
 under the CeCILL-C free/libre software license, it can be used as a
 testbed for the easy and quick development and testing of new
 partitioning and ordering methods.
 .
 o It can be easily interfaced to other programs. The programs
 comprising the SCOTCH project have been designed to run in
 command-line mode without any interactive prompting, so that they can
 be called easily from other programs by means of system() or popen()
 calls, or piped together on a single command line. Moreover, vertex
 labeling capabilities allow for easy renumbering of vertices.
 .
 o It provides many tools to build, check, and display graphs, meshes
 and matrix patterns.
 .
 o It is written in C and uses the POSIX interface, which makes it
 highly portable. PT-SCOTCH uses the MPI interface, and optionally the
 POSIX threads.

Package: ptscotch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 PT-SCOTCH is the MPI version of scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libscotch-dev
Section: libdevel
Architecture: any
Depends: libscotch-6.0 (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-dev
Section: libdevel
Architecture: any
Depends: libptscotch-6.0 (= ${binary:Version}), libscotch-dev (= ${binary:Version}), mpi-default-dev, zlib1g-dev, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Headers and libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

Package: libscotchmetis-dev
Section: libdevel
Architecture: any
Depends: libscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libmetis-dev, libparmetis-dev
Replaces: libmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/Metis compatility interface, providing a free implementation of the
 Metis system for graph partitioning and sparse matrix reordering.

Package: libscotchparmetis-dev
Section: libdevel
Architecture: any
Depends: libptscotch-dev (= ${binary:Version}), ${misc:Depends}
Conflicts: libparmetis-dev
Replaces: libparmetis-dev
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Scotch/ParMetis compatility interface, providing a free implementation of the
 ParMetis system for parallel graph partitioning and sparse matrix reordering.

Package: libscotch-6.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for scotch, which is a set of programs and
 libraries which implement the static mapping and sparse matrix reordering
 algorithms developed within the SCOTCH project.

Package: libptscotch-6.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MPI programs and libraries for graph, mesh and hypergraph partitioning
 Shared libraries package for PT-SCOTCH, the MPI version of scotch, which
 is a set of programs and libraries which implement the static mapping and
 sparse matrix reordering algorithms developed within the SCOTCH project.

=== debian/watch ===
version=3
opts=dversionmangle=s/\.dfsg1$// \
 https://gforge.inria.fr/frs/?group_id=248 /frs/download.php/.*/scotch_([\d.]+)\.ta?r?\.?gz
